
;;; ncurses_gen.scm

;;#define wgetstr(w, s)		wgetnstr(w, s, -1)
(define-public (wgetstr! w s) (wgetnstr! w s #f))
;;#define getnstr(s, n)		wgetnstr(stdscr, s, n)
(define-public (getnstr! s n) (wgetnstr! (stdscr) s n))

;;#define setterm(term)		setupterm(term, 1, (int *)0)
;; FIXME: not impelented?

;;#define fixterm()		reset_prog_mode()
(define-public (fixterm) (reset-prog-mode))
;;#define resetterm()		reset_shell_mode()
(define-public (resetterm) (reset-shell-mode))
;;#define saveterm()		def_prog_mode()
(define-public (saveterm) (def-prog-mode))
;;#define crmode()		cbreak()
(define-public (crmode) (cbreak))
;;#define nocrmode()		nocbreak()
(define-public (nocrmode) (nocbreak))
;;#define gettmode()
;; FIXME: not impelented?

;;; These functions returns (values y x) -- in ncurses notation
;;; FIXME: may be return #f on error?
;;#define getyx(win,y,x)   	(y = (win)?(win)->_cury:ERR, x = (win)?(win)->_curx:ERR)
(define-public (getyx win)
  (let ((y (if (not (null? win))
			 (WINDOW--cury-get win)
			 ERR))
		(x (if (not (null? win))
			 (WINDOW--curx-get win))))
	(values y x)))
;;#define getbegyx(win,y,x)	(y = (win)?(win)->_begy:ERR, x = (win)?(win)->_begx:ERR)
(define-public (getbegyx win)
  (let ((y (if (not (null? win))
			 (WINDOW--begy-get win)
			 ERR))
		(x (if (not (null? win))
			 (WINDOW--begx-get win))))
	(values y x)))
;;#define getmaxyx(win,y,x)	(y = (win)?((win)->_maxy + 1):ERR, x = (win)?((win)->_maxx + 1):ERR)
(define-public (getmaxyx win)
  (let ((y (if (not (null? win))
			 (1+ (WINDOW--maxy-get win))
			 ERR))
		(x (if (not (null? win))
			 (1+ (WINDOW--maxx-get win)))))
	(values y x)))
;;#define getparyx(win,y,x)	(y = (win)?(win)->_pary:ERR, x = (win)?(win)->_parx:ERR)
(define-public (getparyx win)
  (let ((y (if (not (null? win))
			 (WINDOW--pary-get win)
			 ERR))
		(x (if (not (null? win))
			 (WINDOW--parx-get win))))
	(values y x)))
;;#define getsyx(y,x) do { if(newscr->_leaveok) (y)=(x)=-1; \
;;			 else getyx(newscr,(y),(x)); \
;;		    } while(0)
;; FIXME: may '() from (newscr) be checked?
(define-public (getsyx)
  (if (or (null? (newscr))
		  (WINDOW--leaveok-get (newscr)))
	(values ERR ERR)
	(getyx (newscr))))
;;#define setsyx(y,x) do { if((y)==-1 && (x)==-1) newscr->_leaveok=TRUE; \
;;			 else {newscr->_leaveok=FALSE;wmove(newscr,(y),(x));} \
;;		    } while(0)
(define-public (setsyx y x)
  (if (not (null? (newscr)))
	(if (and (= y ERR)
			 (= x ERR))
	  (WINDOW--leaveok-set (newscr) #t)
	  (begin
		(WINDOW--leaveok-set (newscr) #f)
		(wmove (newscr) y x)))))

;;/* It seems older SYSV curses versions define these */
;;; These functions returns atomic values
;;; FIXME: may be return #f on error?
;;#define getattrs(win)		((win)?(win)->_attrs:A_NORMAL)
(define-public (getattrs win)
  (if (not (null? win))
	(WINDOW--attrs-get)
	A_NORMAL))
;;#define getcurx(win)		((win)?(win)->_curx:ERR)
(define-public (getcurx win)
  (if (not (null? win))
	(WINDOW--curx-get)
	ERR))
;;#define getcury(win)		((win)?(win)->_cury:ERR)
(define-public (getcury win)
  (if (not (null? win))
	(WINDOW--cury-get)
	ERR))
;;#define getbegx(win)		((win)?(win)->_begx:ERR)
(define-public (getbegx win)
  (if (not (null? win))
	(WINDOW--begx-get)
	ERR))
;;#define getbegy(win)		((win)?(win)->_begy:ERR)
(define-public (getbegy win)
  (if (not (null? win))
	(WINDOW--begy-get)
	ERR))
;;#define getmaxx(win)		((win)?((win)->_maxx + 1):ERR)
(define-public (getmaxx win)
  (if (not (null? win))
	(1+ (WINDOW--maxx-get))
	ERR))
;;#define getmaxy(win)		((win)?((win)->_maxy + 1):ERR)
(define-public (getmaxy win)
  (if (not (null? win))
	(1+ (WINDOW--maxy-get))
	ERR))
;;#define getparx(win)		((win)?(win)->_parx:ERR)
(define-public (getparx win)
  (if (not (null? win))
	(WINDOW--parx-get)
	ERR))
;;#define getpary(win)		((win)?(win)->_pary:ERR)
(define-public (getpary win)
  (if (not (null? win))
	(WINDOW--pary-get)
	ERR))

;;#define wstandout(win)      	(wattrset(win,A_STANDOUT))
(define-public (wstandout win) (wattrset win A_STANDOUT))
;;#define wstandend(win)      	(wattrset(win,A_NORMAL))
(define-public (wstandend win) (wattrset win A_NORMAL))
;;#define wattr_set(win,a,p,opts) ((win)->_attrs = (((a) & ~A_COLOR) | COLOR_PAIR(p)), OK)
;; FIXME: what to do with opts?
(define-public (wattr-set win a p)
 (if (not (null? win))
   (begin
	 (WINDOW--attrs-set (logior (logand a (lognot A_COLOR)) (COLOR_PAIR p)))
	 OK)))

;;#define wattron(win,at)		wattr_on(win, at, (void *)0)
(define-public (wattron win at) (wattr_on win at '()))
;;#define wattroff(win,at)	wattr_off(win, at, (void *)0)
(define-public (wattroff win at) (wattr_off win at '()))
;;#define wattrset(win,at)    	((win)->_attrs = (at))
;; FIXME: need this carefulness?
(define-public (wattrset win at)
  (if (not (null? win))
	(WINDOW--attrs-set win at)))

;; FIXME: more carefulness with '()?

;;#define scroll(win)		wscrl(win,1)
(define-public (scroll win) (wscrl win 1))

;;#define touchwin(win)		wtouchln((win), 0, getmaxy(win), 1)
(define-public (touchwin win) (wtouchln win 0 (getmaxy win) 1))
;;#define touchline(win, s, c)	wtouchln((win), s, c, 1)
(define-public (touchline win s c) (wtouchln win s c 1))
;;#define untouchwin(win)		wtouchln((win), 0, getmaxy(win), 0)
(define-public (untouchwin win) (wtouchln win 0 (getmaxy win) 0))

;;#define box(win, v, h)		wborder(win, v, v, h, h, 0, 0, 0, 0)
(define-public (box win v h) (wborder win v v h h 0 0 0 0))
;;#define border(ls, rs, ts, bs, tl, tr, bl, br)	wborder(stdscr, ls, rs, ts, bs, tl, tr, bl, br)
(define-public (border ls rs ts bs tl tr bl br)
  (wborder (stdscr) ls rs ts bs tl tr bl br))
;;#define hline(ch, n)		whline(stdscr, ch, n)
(define-public (hline ch n) (whline (stdscr) ch n))
;;#define vline(ch, n)		wvline(stdscr, ch, n)
(define-public (vline ch n) (wvline (stdscr) ch n))

;;#define winstr(w, s)		winnstr(w, s, -1)
(define-public (winstr! w s) (winnstr! w s #f))
;;#define winchstr(w, s)		winchnstr(w, s, -1)
(define-public (winchstr! w s) (winchnstr! w s #f))
;;#define winsstr(w, s)		winsnstr(w, s, -1)
(define-public (winsstr w s) (winsnstr w s #f))

;;#define redrawwin(w)		wredrawln(w, 0, w->_maxy+1)
(define-public (redrawwin w)
  (if (not (null? win))
	(wredrawln w 0 (1+ (WINDOW--maxy-get win)))))
;;#define waddstr(win,str)	waddnstr(win,str,-1)
(define-public (waddstr win str) (waddnstr win str #f))
;;#define waddchstr(win,str)	waddchnstr(win,str,-1)
(define-public (waddchstr win str) (waddchnstr win str #f))

;;/*
;; * pseudo functions for standard screen
;; */

;;#define addch(ch)      		waddch(stdscr,ch)
(define-public (addch ch) (waddch (stdscr) ch))
;;#define addchnstr(str,n)	waddchnstr(stdscr,str,n)
(define-public (addchnstr str n) (waddchnstr (stdscr) str n))
;;#define addchstr(str)		waddchstr(stdscr,str)
(define-public (addchstr str) (waddchstr (stdscr) str))
;;#define addnstr(str,n)		waddnstr(stdscr,str,n)
(define-public (addnstr str n) (waddnstr (stdscr) str n))
;;#define addstr(str)    		waddnstr(stdscr,str,-1)
(define-public (addstr str) (waddnstr (stdscr) str #f))
;;#define attroff(at)    		wattroff(stdscr,at)
(define-public (attroff at) (wattroff (stdscr) at))
;;#define attron(at)     		wattron(stdscr,at)
(define-public (attron at) (wattron (stdscr) at))
;;#define attrset(at)    		wattrset(stdscr,at)
(define-public (attrset at) (wattrset (stdscr) at))
;;#define bkgd(ch)		wbkgd(stdscr,ch)
(define-public (bkgd ch) (wbkgd (stdscr) ch))
;;#define bkgdset(ch)		wbkgdset(stdscr,ch)
(define-public (bkgdset ch) (wbkgdset (stdscr) ch))
;;#define clear()        		wclear(stdscr)
(define-public (clear) (wclear (stdscr)))
;;#define clrtobot()     		wclrtobot(stdscr)
(define-public (clrtobot) (wclrtobot (stdscr)))
;;#define clrtoeol()     		wclrtoeol(stdscr)
(define-public (clrtoeol) (wclrtoeol (stdscr)))
;;#define color_set(c,o)		wcolor_set(stdscr,c,o)
(define-public (color-set c o) (wcolor-set (stdscr) c o))
;;#define delch()        		wdelch(stdscr)
(define-public (delch) (wdelch (stdscr)))
;;#define deleteln()     		winsdelln(stdscr,-1)
(define-public (deleteln) (winsdelln (stdscr) -1))
;;#define echochar(c)		wechochar(stdscr,c)
(define-public (echochar c) (wechochar (stdscr) c))
;;#define erase()        		werase(stdscr)
(define-public (erase) (werase (stdscr)))
;;#define getch()        		wgetch(stdscr)
(define-public (getch) (wgetch (stdscr)))
;;#define getstr(str)    		wgetstr(stdscr,str)
(define-public (getstr! str) (wgetstr! (stdscr) str))
;;#define inch()       		winch(stdscr)
(define-public (inch) (winch (stdscr)))
;;#define inchnstr(s,n)		winchnstr(stdscr,s,n)
(define-public (inchnstr s n) (winchnstr (stdscr) s n))
;;#define inchstr(s)		winchstr(stdscr,s)
(define-public (inchstr s) (winchstr (stdscr) s))
;;#define innstr(s,n)		winnstr(stdscr,s,n)
(define-public (innstr s n) (winnstr (stdscr) s n))
;;#define insch(c)       		winsch(stdscr,c)
(define-public (insch c) (winsch (stdscr) c))
;;#define insdelln(n)		winsdelln(stdscr,n)
(define-public (insdelln n) (winsdelln (stdscr) n))
;;#define insertln()     		winsdelln(stdscr,1)
(define-public (insertln) (winsdelln (stdscr) 1))
;;#define insnstr(s,n)		winsnstr(stdscr,s,n)
(define-public (insnstr s n) (winsnstr (stdscr) s n))
;;#define insstr(s)		winsstr(stdscr,s)
(define-public (insstr s) (winsstr (stdscr) s))
;;#define instr(s)		winstr(stdscr,s)
(define-public (instr s) (winstr (stdscr) s))
;;#define move(y,x)     		wmove(stdscr,y,x)
(define-public (move y x) (wmove (stdscr) y x))
;;#define refresh()      		wrefresh(stdscr)
(define-public (refresh) (wrefresh (stdscr)))
;;#define scrl(n)			wscrl(stdscr,n)
(define-public (scrl n) (wscrl (stdscr) n))
;;#define setscrreg(t,b) 		wsetscrreg(stdscr,t,b)
(define-public (setscrreg t b) (wsetscrreg (stdscr) t b))
;;#define standend()     		wstandend(stdscr)
(define-public (standend) (wstandend (stdscr)))
;;#define standout()     		wstandout(stdscr)
(define-public (standout) (wstandout (stdscr)))
;;#define timeout(delay)		wtimeout(stdscr,delay)
(define-public (timeout delay) (wtimeout (stdscr) delay))
;;#define wdeleteln(win)     	winsdelln(win,-1)
(define-public (wdeleteln win) (winsdelln win -1))
;;#define winsertln(win)     	winsdelln(win,1)
(define-public (winsertln win) (winsdelln win 1))

;;/*
;; * mv functions
;; */

;;#define mvwaddch(win,y,x,ch)    	(wmove(win,y,x) == ERR ? ERR : waddch(win,ch))
(define-public (mvwaddch win y x ch)
  (if (= (wmove win y x) ERR)
	ERR
	(waddch win ch)))
;;#define mvwaddchnstr(win,y,x,str,n)	(wmove(win,y,x) == ERR ? ERR : waddchnstr(win,str,n))
(define-public (mvwaddchnstr win y x str n)
  (if (= (wmove win y x) ERR)
	ERR
	(waddchnstr win str n)))
;;#define mvwaddchstr(win,y,x,str)  	(wmove(win,y,x) == ERR ? ERR : waddchnstr(win,str,-1))
(define-public (mvwaddchstr win y x str)
  (if (= (wmove win y x) ERR)
	ERR
	(waddchnstr win str #f)))
;;#define mvwaddnstr(win,y,x,str,n)	(wmove(win,y,x) == ERR ? ERR : waddnstr(win,str,n))
(define-public (mvwaddnstr win y x str n)
  (if (= (wmove win y x) ERR)
	ERR
	(waddnstr win str n)))
;;#define mvwaddstr(win,y,x,str)  	(wmove(win,y,x) == ERR ? ERR : waddnstr(win,str,-1))
(define-public (mvwaddstr win y x str)
  (if (= (wmove win y x) ERR)
	ERR
	(waddnstr win str #f)))
;;#define mvwdelch(win,y,x)       	(wmove(win,y,x) == ERR ? ERR : wdelch(win))
(define-public (mvwdelch win y x)
  (if (= (wmove win y x) ERR)
	ERR
	(wdelch win)))
;;#define mvwgetch(win,y,x)       	(wmove(win,y,x) == ERR ? ERR : wgetch(win))
(define-public (mvwgetch win y x)
  (if (= (wmove win y x) ERR)
	ERR
	(wgetch win)))
;;#define mvwgetnstr(win,y,x,str,n)    	(wmove(win,y,x) == ERR ? ERR : wgetnstr(win,str,n))
(define-public (mvwgetnstr! win y x str n)
  (if (= (wmove win y x) ERR)
	ERR
	(wgetnstr! win str n)))
;;#define mvwgetstr(win,y,x,str)      	(wmove(win,y,x) == ERR ? ERR : wgetstr(win,str))
(define-public (mvwgetstr! win y x str)
  (if (= (wmove win y x) ERR)
	ERR
	(wgetstr! win str)))
;;#define mvwhline(win,y,x,c,n)     	(wmove(win,y,x) == ERR ? ERR : whline(win,c,n))
(define-public (mvwhline win y x c n)
  (if (= (wmove win y x) ERR)
	ERR
	(whline win c n)))
;;#define mvwinch(win,y,x)        	(wmove(win,y,x) == ERR ? (chtype)ERR : winch(win))
(define-public (mvwinch win y x)
  (if (= (wmove win y x) ERR)
	ERR
	(winch win)))
;;#define mvwinchnstr(win,y,x,s,n)	(wmove(win,y,x) == ERR ? ERR : winchnstr(win,s,n))
(define-public (mvwinchnstr! win y x s n)
  (if (= (wmove win y x) ERR)
	ERR
	(winchnstr! win s n)))
;;#define mvwinchstr(win,y,x,s)		(wmove(win,y,x) == ERR ? ERR : winchstr(win,s))
(define-public (mvwinchstr! win y x s)
  (if (= (wmove win y x) ERR)
	ERR
	(winchstr! win s)))
;;#define mvwinnstr(win,y,x,s,n)		(wmove(win,y,x) == ERR ? ERR : winnstr(win,s,n))
(define-public (mvwinnstr! win y x s n)
  (if (= (wmove win y x) ERR)
	ERR
	(winnstr! win s n)))
;;#define mvwinsch(win,y,x,c)     	(wmove(win,y,x) == ERR ? ERR : winsch(win,c))
(define-public (mvwinsch win y x c)
  (if (= (wmove win y x) ERR)
	ERR
	(winsch win c)))
;;#define mvwinsnstr(win,y,x,s,n)		(wmove(win,y,x) == ERR ? ERR : winsnstr(win,s,n))
(define-public (mvwinsnstr win y x s n)
  (if (= (wmove win y x) ERR)
	ERR
	(winsnstr win s n)))
;;#define mvwinsstr(win,y,x,s)		(wmove(win,y,x) == ERR ? ERR : winsstr(win,s))
(define-public (mvwinsstr win y x s)
  (if (= (wmove win y x) ERR)
	ERR
	(winsstr win s)))
;;#define mvwinstr(win,y,x,s)		(wmove(win,y,x) == ERR ? ERR : winstr(win,s))
(define-public (mvwinstr win y x s)
  (if (= (wmove win y x) ERR)
	ERR
	(winstr win s)))
;;#define mvwvline(win,y,x,c,n)     	(wmove(win,y,x) == ERR ? ERR : wvline(win,c,n))
(define-public (mvwvline win y x c n)
  (if (= (wmove win y x) ERR)
	ERR
	(wvline win c n)))

;;#define mvaddch(y,x,ch)         	mvwaddch(stdscr,y,x,ch)
(define-public (mvaddch y x ch) (mvwaddch (stdscr) y x ch))
;;#define mvaddchnstr(y,x,str,n)		mvwaddchnstr(stdscr,y,x,str,n)
(define-public (mvaddchnstr y x str n) (mvwaddchnstr (stdscr) y x str n))
;;#define mvaddchstr(y,x,str)		mvwaddchstr(stdscr,y,x,str)
(define-public (mvaddchstr y x str) (mvwaddchstr (stdscr) y x str))
;;#define mvaddnstr(y,x,str,n)		mvwaddnstr(stdscr,y,x,str,n)
(define-public (mvaddnstr y x str n) (mvwaddnstr (stdscr) y x str n))
;;#define mvaddstr(y,x,str)       	mvwaddstr(stdscr,y,x,str)
(define-public (mvaddstr y x str) (mvwaddstr (stdscr) y x str))
;;#define mvdelch(y,x)            	mvwdelch(stdscr,y,x)
(define-public (mvdelch y x) (mvwdelch (stdscr) y x))
;;#define mvgetch(y,x)            	mvwgetch(stdscr,y,x)
(define-public (mvgetch y x) (mvwgetch (stdscr) y x))
;;#define mvgetnstr(y,x,str,n)		mvwgetnstr(stdscr,y,x,str,n)
(define-public (mvgetnstr! y x str n) (mvwgetnstr! (stdscr) y x str n))
;;#define mvgetstr(y,x,str)           	mvwgetstr(stdscr,y,x,str)
(define-public (mvgetstr! y x c n) (mvwgetstr! (stdscr) y x str))
;;#define mvhline(y,x,c,n)		mvwhline(stdscr,y,x,c,n)
(define-public (mvhline y x c n) (mvwhline (stdscr) y x c n))
;;#define mvinch(y,x)             	mvwinch(stdscr,y,x)
(define-public (mvinch y x) (mvwinch (stdscr) y x))
;;#define mvinchnstr(y,x,s,n)		mvwinchnstr(stdscr,y,x,s,n)
(define-public (mvinchnstr! y x s n) (mvwinchnstr! (stdscr) y x s n))
;;#define mvinchstr(y,x,s)		mvwinchstr(stdscr,y,x,s)
(define-public (mvinchstr! y x s) (mvwinchstr! (stdscr) y x s))
;;#define mvinnstr(y,x,s,n)		mvwinnstr(stdscr,y,x,s,n)
(define-public (mvinnstr! y x s n) (mvwinnstr! (stdscr) y x s n))
;;#define mvinsch(y,x,c)          	mvwinsch(stdscr,y,x,c)
(define-public (mvinsch y x c) (mvwinsch (stdscr) y x c))
;;#define mvinsnstr(y,x,s,n)		mvwinsnstr(stdscr,y,x,s,n)
(define-public (mvinsnstr y x s n) (mvwinsnstr (stdscr) y x s n))
;;#define mvinsstr(y,x,s)			mvwinsstr(stdscr,y,x,s)
(define-public (mvinsstr! y x s) (mvwinsstr! (stdscr) y x s))
;;#define mvinstr(y,x,s)			mvwinstr(stdscr,y,x,s)
(define-public (mvinstr! y x s) (mvwinstr! (stdscr) y x s))
;;#define mvvline(y,x,c,n)		mvwvline(stdscr,y,x,c,n)
(define-public (mvvline y x c n) (mvwvline (stdscr) y x c n))

;;/*
;; * XSI curses macros for XPG4 conformance.
;; * The underlying functions needed to make these work are:
;; * waddnwstr(), waddchnwstr(), wadd_wch(), wborder_set(), wchgat(),
;; * wecho_wchar(), wgetn_wstr(), wget_wch(), whline_set(), vhline_set(),
;; * winnwstr(), wins_nwstr(), wins_wch(), win_wch(), win_wchnstr().
;; * Except for wchgat(), these are not yet implemented.  They will be someday.
;; */
;;#define add_wch(c)			wadd_wch(stdscr,c)
;;#define addnwstr(wstr,n)		waddnwstr(stdscr,wstr,n)
;;#define addwstr(wstr,n)			waddnwstr(stdscr,wstr,-1)
;;#define attr_get(a,pair,opts)		wattr_get(stdscr,a,pair,opts)
;;#define attr_off(a,opts)		wattr_off(stdscr,a,opts)
;;#define attr_on(a,opts)			wattr_on(stdscr,a,opts)
;;#define attr_set(a,pair,opts)		wattr_set(stdscr,a,pair,opts)
;;#define box_set(w,v,h)			wborder_set(w,v,v,h,h,0,0,0,0)
;;#define chgat(n,a,c,o)			wchgat(stdscr,n,a,c,o)
(define-public (chgat n a c) (wchgat (stdscr) n a c))
;;#define echo_wchar(c)			wecho_wchar(stdscr,c)
;;#define getbkgd(win)			((win)->_bkgd)
;;#define get_wch(c)			wget_wch(stdscr,c)
;;#define get_wstr(t)			wgetn_wstr(stdscr,t,-1)
;;#define getn_wstr(t,n)			wgetn_wstr(stdscr,t,n)
;;#define hline_set(c,n)			whline_set(stdscr,c,n)
;;#define in_wch(c)			win_wch(stdscr,c)
;;#define in_wchnstr(c,n)			win_wchnstr(stdscr,c,n)
;;#define in_wchstr(c)			win_wchnstr(stdscr,c,-1)
;;#define innwstr(c,n)			winnwstr(stdscr,c,n)
;;#define ins_nwstr(t,n)			wins_nwstr(stdscr,t,n)
;;#define ins_wch(c)			wins_wch(stdscr,c)
;;#define ins_wstr(t)			wins_nwstr(stdscr,t,-1)
;;#define inwstr(c)			winnwstr(stdscr,c,-1)

;;#define mvadd_wch(y,x,c)		mvwadd_wch(stdscr,y,x,c)
;;#define mvaddnwstr(y,x,wstr,n)		mvwaddnwstr(stdscr,y,x,wstr,n)
;;#define mvaddwstr(y,x,wstr,n)		mvwaddnwstr(stdscr,y,x,wstr,-1)
;;#define mvchgat(y,x,n,a,c,o)		mvwchgat(stdscr,y,x,n,a,c,o)
(define-public (mvchgat y x n a c) (mvwchgat (stdscr) y x n a c))
;;#define mvget_wch(y,x,c)		mvwget_wch(stdscr,y,x,c)
;;#define mvget_wstr(y,x,t)		mvwgetn_wstr(stdscr,y,x,t,-1)
;;#define mvgetn_wstr(y,x,t,n)		mvwgetn_wstr(stdscr,y,x,t,n)
;;#define mvhline_set(y,x,c,n)		mvwhline_set(stdscr,y,x,c,n)
;;#define mvin_wch(y,x,c)			mvwin_wch(stdscr,y,x,c)
;;#define mvin_wchnstr(y,x,c,n)		mvwin_wchnstr(stdscr,y,x,c,n)
;;#define mvin_wchstr(y,x,c)		mvwin_wchnstr(stdscr,y,x,c,-1)
;;#define mvinnwstr(y,x,c,n)		mvwinnwstr(stdscr,y,x,c,n)
;;#define mvins_nwstr(y,x,t,n)		mvwins_nwstr(stdscr,y,x,t,n)
;;#define mvins_wch(y,x,c)		mvwins_wch(stdscr,y,x,c)
;;#define mvins_wstr(y,x,t)		mvwins_nwstr(stdscr,y,x,t,-1)
;;#define mvinwstr(y,x,c)			mvwinnwstr(stdscr,y,x,c,-1)
;;#define mvvline_set(y,x,c,n)		mvwvline_set(stdscr,y,x,c,n)

;;#define mvwadd_wch(win,y,x,c)		(wmove(win,y,x) == ERR ? ERR : wadd_wch(stdscr,c))
;;#define mvwaddnwstr(win,y,x,wstr,n)	(wmove(win,y,x) == ERR ? ERR : waddnwstr(stdscr,wstr,n))
;;#define mvwaddwstr(win,y,x,wstr,n)	(wmove(win,y,x) == ERR ? ERR : waddnwstr(stdscr,wstr,-1))
;;#define mvwchgat(win,y,x,n,a,c,o)	(wmove(win,y,x) == ERR ? ERR : wchgat(win,n,a,c,o))
(define-public (mvwchgat win y x n a c)
  (if (= (wmove win y x) ERR)
	ERR
	(wchgat win n a c)))
;;#define mvwget_wch(win,y,x,c)		(wmove(win,y,x) == ERR ? ERR : wget_wch(win,c))
;;#define mvwget_wstr(win,y,x,t)		(wmove(win,y,x) == ERR ? ERR : wgetn_wstr(win,t,-1))
;;#define mvwgetn_wstr(win,y,x,t,n)	(wmove(win,y,x) == ERR ? ERR : wgetn_wstr(win,t,n))
;;#define mvwhline_set(win,y,x,c,n)	(wmove(win,y,x) == ERR ? ERR : whline_set(win,c,n))
;;#define mvwin_wch(win,y,x,c)		(wmove(win,y,x) == ERR ? ERR : win_wch(win,c))
;;#define mvwin_wchnstr(win,y,x,c,n)	(wmove(win,y,x) == ERR ? ERR : win_wchnstr(stdscr,c,n))
;;#define mvwin_wchstr(win,y,x,c)		(wmove(win,y,x) == ERR ? ERR : win_wchnstr(stdscr,c,-1))
;;#define mvwinnwstr(win,y,x,c,n)		(wmove(win,y,x) == ERR ? ERR : winnwstr(stdscr,c,n))
;;#define mvwins_nwstr(win,y,x,t,n)	(wmove(win,y,x) == ERR ? ERR : wins_nwstr(stdscr,t,n))
;;#define mvwins_wch(win,y,x,c)		(wmove(win,y,x) == ERR ? ERR : wins_wch(stdscr,c))
;;#define mvwins_wstr(win,y,x,t)		(wmove(win,y,x) == ERR ? ERR : wins_nwstr(stdscr,t,-1))
;;#define mvwinwstr(win,y,x,c)		(wmove(win,y,x) == ERR ? ERR : winnwstr(stdscr,c,-1))
;;#define mvwvline_set(win,y,x,c,n)	(wmove(win,y,x) == ERR ? ERR : wvline_set(win,c,n))

;; FIXME: is that correct?
;;#define slk_attr_off(a,v)		((v) ? ERR : slk_attroff(a))
(define-public (slk_attr_off a v)
  (if (not (= v 0))
	ERR
	(slk_attroff a)))
;;#define slk_attr_on(a,v)		((v) ? ERR : slk_attron(a))
(define-public (slk_attr_on a v)
  (if (not (= v 0))
	ERR
	(slk_attron a)))

;; FIXME: is it needed anyway?
;;#define vid_attr(a,pair,opts)		vidattr(a)
(define-public (vid_attr a pair) (vidattr a))
;; FIXME: not implemented?
;;#define vline_set(c,n)			wvline_set(stdscr,c,n)
;; FIXME: not implemented?
;;#define waddwstr(win,wstr,n)		waddnwstr(win,wstr,-1)
;;#define wattr_get(win,a,p,opts)		((void)((a) != 0 && (*(a) = (win)->_attrs)), \
;;					 (void)((p) != 0 && (*(p) = PAIR_NUMBER((win)->_attrs))), \
;;					 OK)
(define-public (wattr_get win a p)
  (if (not (null? win))
	(begin
	  (set! a (WINDOW--attrs-get win))
	  (set! p (PAIR-NUMBER (WINDOW--attrs-get win)))
	  OK)))
;;#define wget_wstr(w,t)			wgetn_wstr(w,t,-1)
;;#define win_wchstr(w,c)			win_wchnstr(w,c,-1)
;;#define wins_wstr(w,t)			wins_nwstr(w,t,-1)
;;#define winwstr(w,c)			winnwstr(w,c,-1)


;;/*
;; * XSI curses deprecates SVr4 vwprintw/vwscanw, which are supposed to use
;; * varargs.h.  It adds new calls vw_printw/vw_scanw, which are supposed to
;; * use POSIX stdarg.h.  The ncurses versions of vwprintw/vwscanw already
;; * use stdarg.h, so...
;; */
;;#define vw_printw		vwprintw
;;#define vw_scanw		vwscanw

